/* Copyright (C) 2023 Facility for Antiproton and Ion Research in Europe, Darmstadt
   SPDX-License-Identifier: GPL-3.0-only
   Authors: Dominik Smith [committer], Felix Weiglhofer */
#pragma once

#include "Calibrate.h"
#include "CalibrateSetup.h"
#include "CbmTofDigi.h"
#include "SubChain.h"

#include <gsl/span>
#include <memory>

namespace cbm::algo::tof
{

  class CalibratorChain : public SubChain {

   public:
    using ReturnType = Calibrate::resultType;

    CalibratorChain()  = default;
    ~CalibratorChain() = default;

    void Init();

    /**
     * @brief Apply calibration to digis
     */
    ReturnType Run(gsl::span<CbmTofDigi> digis);

   private:
    std::unique_ptr<Calibrate> fCalibrate;
  };

}  // namespace cbm::algo::tof
