/* Copyright (C) 2023 FIAS Frankfurt Institute for Advanced Studies, Frankfurt / Main
   SPDX-License-Identifier: GPL-3.0-only
   Authors: Felix Weiglhofer [committer] */
#include "HitfinderChain.h"

#include "config/Yaml.h"

using namespace cbm::algo;
using namespace cbm::algo::tof;

void HitfinderChain::Init()
{
  auto setup = config::ReadFromFile<HitfindSetup>(Opts().ParamsDir() / "TofHitfinderPar.yaml");
  fHitfind   = std::make_unique<Hitfind>(setup);
}

HitfinderChain::ReturnType HitfinderChain::Run(gsl::span<CbmTofDigi> digis)
{
  auto ret = (*fHitfind)(digis);

  L_(info) << "TS contains " << std::get<0>(ret).NElements() << " TOF Hits";
  return ret;
}
